diff --git a/util/datagen/src/main/java/net/minecraft/datagen/ConsolidationGrouper.java b/util/datagen/src/main/java/net/minecraft/datagen/ConsolidationGrouper.java
new file mode 100644
index 000000000..2f96f67e6
--- /dev/null
+++ b/util/datagen/src/main/java/net/minecraft/datagen/ConsolidationGrouper.java
@@ -0,0 +1,108 @@
+package net.minecraft.datagen;
+
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.Arrays;
+import java.util.List;
+import java.util.Set;
+
+final class ConsolidationGrouper {
+    private ConsolidationGrouper() {}
+
+    private static final String[][] FAMILY_PREFIXES = {
+        {"pressure_plate_", "pressure_plates"},
+        {"fence_gate_", "fence_gates"},
+        {"fence_", "fences"},
+        {"slab_", "slabs"},
+        {"stairs_", "stairs"},
+        {"wall_", "walls"},
+        {"button_", "buttons"},
+        {"trapdoor_", "trapdoors"},
+        {"chest_", "chests"},
+        {"door_", "doors"},
+        {"sign", "signs"},
+        {"brick_", "bricks"},
+        {"planks_", "planks"},
+    };
+
+    private static final Set<String> MATERIALS = Set.of(
+        "diamond", "gold", "iron", "steel", "lapis", "olivine", "quartz", "rubyglass", "clay", "glass");
+
+    private static final Set<String> RAW_STONE = Set.of(
+        "stone", "basalt", "granite", "limestone", "permafrost", "netherrack",
+        "gloomstone", "sandstone", "marble", "brimstone", "slate");
+
+    static void apply(RecipeGroup<?> workbench) {
+        for (Object o : workbench) {
+            if (!(o instanceof RecipeEntryCrafting<?, ?> recipe)) continue;
+            if (recipe.consolidationGroup != null) continue; // hand-declared groups win
+            ItemStack output = outputOf(recipe);
+            if (output == null) continue;
+            String family = familyOf(cleanName(output));
+            if (family == null) continue;
+            String bucket = bucketOfInputs(recipe);
+            if (bucket == null) continue;
+            recipe.consolidationGroup = bucket + "_" + family;
+        }
+    }
+
+    private static String familyOf(String outputName) {
+        for (String[] entry : FAMILY_PREFIXES) {
+            if (outputName.startsWith(entry[0])) return entry[1];
+        }
+
+        if (outputName.endsWith("_polished")) return "polished";
+        return null;
+    }
+
+    private static String bucketOfInputs(RecipeEntryCrafting<?, ?> recipe) {
+        for (RecipeSymbol symbol : inputsOf(recipe)) {
+            if (symbol == null || symbol.getItemGroup() != null || symbol.getStack() == null) continue;
+            String bucket = bucketOf(cleanName(symbol.getStack()));
+            if (bucket != null) return bucket;
+        }
+        return null;
+    }
+
+    static String bucketOf(String inputName) {
+        if (inputName.startsWith("planks_oak") || inputName.startsWith("log_")) return "wood"; // planks + logs
+        if (inputName.startsWith("cobble_")) return "cobble";
+        if (inputName.endsWith("_polished")) return "polished";
+        if (inputName.startsWith("brick_") || inputName.endsWith("_brick")) {
+            return containsMaterial(inputName) ? "material_brick" : "stone_brick";
+        }
+        if (RAW_STONE.contains(inputName)) return "stone";
+        if (containsMaterial(inputName)) return "material";
+        return null;
+    }
+
+    private static boolean containsMaterial(String name) {
+        for (String material : MATERIALS) {
+            if (name.contains(material)) return true;
+        }
+        return false;
+    }
+
+    private static String cleanName(ItemStack stack) {
+        String value = stack.getItem().namespaceID.value();
+        int slash = value.indexOf('/');
+        return slash >= 0 ? value.substring(slash + 1) : value;
+    }
+
+    private static ItemStack outputOf(RecipeEntryCrafting<?, ?> recipe) {
+        if (recipe instanceof RecipeEntryCraftingShaped shaped) return shaped.getOutput();
+        if (recipe instanceof RecipeEntryCraftingShapeless shapeless) return shapeless.getOutput();
+        return null;
+    }
+
+    private static List<RecipeSymbol> inputsOf(RecipeEntryCrafting<?, ?> recipe) {
+        if (recipe instanceof RecipeEntryCraftingShaped shaped) return Arrays.asList(shaped.getInput());
+        if (recipe instanceof RecipeEntryCraftingShapeless shapeless) return shapeless.getInput();
+        return List.of();
+    }
+}
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java
index 8d1c21f92..c69e02cfe 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java
@@ -57,6 +57,7 @@ public class RecipesGenerator {
         List<String> remainingEntries;
 
         WorkbenchGenerator.generate();
+        ConsolidationGrouper.apply(Registries.RECIPES.WORKBENCH);
         if (DEBUG) {
             remainingEntries = getMissingIds(Registries.RECIPES.WORKBENCH, new File("src/main/resources/recipes/workbench.json"));
             if (remainingEntries.isEmpty()) {
